(function($) {
    $.fn.KNResponsiveMenu = function(options){
        
        // setup options
        var defaults = {
	        wrapperID: '#wrapper',
	        menuID: '#menu',
	        menuList: null,
	        closeBtn: '#close_button',
	        closeBtnPositonTop: '10px',
	        closeBtnPositonBottom: null,
	        menuBtn: '#menu_button',
	        menuBtnPositonTop: null,
	        menuBtnPositonBottom: '70px',
	        pagetopBtn: '#pagetop_button',
	        pagetopBtnPositonTop: null,
	        pagetopBtnPositonBottom: '10px',
            pageTop: false,
            mediaQuery: [ 480, 768, 769 ],
            displayMode: 1
        };
        
        var setting = $.extend(defaults, options);
        
        var current_scrollY = 0;
		var menuflg = false;
		var menu_size = 0;
				
		function init_menu_size() {
			if ( $(window).width() > setting.mediaQuery[0] ) {
				menu_size = 240;
			} else {
				menu_size = $(window).width()-50-20;
			}
			$(setting.menuID).css({
				width: menu_size,
				left: -menu_size
			});
		}
		
		function init_menu_button() {
			
			$(setting.menuBtn).append('<span></span>');
			
			if (setting.pageTop) {
				var matchs = setting.pagetopBtn.match(/^#(.*)$/);
				$(setting.wrapperID).after('<div id=' + matchs[matchs.length-1] + '></div>'); // 要素を追加パターン
				$(setting.pagetopBtn).empty().append('<span></span>');
	        } else {
		        $(setting.pagetopBtn).remove();
	        }
	        
	        var matchs = setting.closeBtn.match(/^#(.*)$/);
	        $(setting.wrapperID).after('<div id=' + matchs[matchs.length-1] + '></div>'); // 要素を追加パターン
	        $(setting.closeBtn).empty().append('<span></span>');
	        $(setting.closeBtn).css({
				display: 'none'
			});
	        
	        var matchs = setting.menuBtn.match(/^#(.*)$/);
	        $(setting.wrapperID).after('<div id=' + matchs[matchs.length-1] + '></div>'); // 要素を追加パターン
	        $(setting.menuBtn).empty().append('<span></span>');
	        
	        if (setting.displayMode === 2) {
		        if (window.matchMedia('(min-width: ' + setting.mediaQuery[1] + 'px)').matches) {
		        	$(setting.closeBtn).remove();
		        	$(setting.menuBtn).remove();
		        	$(setting.pagetopBtn).remove();
		        }
	        } else if (setting.displayMode === 3) {
		        if (window.matchMedia('(min-width: ' + setting.mediaQuery[2] + 'px)').matches) {
			        $(setting.closeBtn).remove();
		        	$(setting.menuBtn).remove();
		        	$(setting.pagetopBtn).remove();
			    }
	        }
	        
			if (setting.closeBtnPositonBottom != null) {
				$(setting.closeBtn).css({
					bottom: setting.closeBtnPositonBottom
				});
			} else {
				$(setting.closeBtn).css({
					top: setting.closeBtnPositonTop
				});
			}
			
			if (setting.menuBtnPositonTop != null) {
				$(setting.menuBtn).css({
					top: setting.menuBtnPositonTop
				});
			} else {
				$(setting.menuBtn).css({
					bottom: setting.menuBtnPositonBottom
				});
			}
			
			if (setting.pageTop) {
				if (setting.pagetopBtnPositonTop != null) {
		        	$(setting.pagetopBtn).css({
						top: setting.pagetopBtnPositonTop
					});
				} else {
		        	$(setting.pagetopBtn).css({
						bottom: setting.pagetopBtnPositonBottom
					});
				}
			}
		}
		
		init_menu_button();
		init_menu_size();
		
		$(window).scroll( function() {
		    
	        if ($(this).scrollTop() > 200) {
		        if (setting.pageTop) {
	            	$(setting.pagetopBtn).addClass("visible_button");
	            }
	            $(setting.menuBtn).addClass("visible_button");
	        } else {
		        if (setting.pageTop) {
	            	$(setting.pagetopBtn).removeClass("visible_button");
	            }
	            $(setting.menuBtn).removeClass("visible_button");
	        }
	        
	    });
		
		function visibleMenu() {
			if ( !menuflg ) {
				
				if (setting.menuList != null) {
					$(setting.menuID).empty();
					$(setting.menuList).clone().appendTo($(setting.menuID));
					$(setting.menuID).wrapInner('<div id="menu_content"></div>');
				}
				
				$(setting.closeBtn).css({
					display: 'block'
				});
				
				current_scrollY = $( window ).scrollTop(); 
				$(setting.wrapperID).css({
					position: 'fixed',
					width: '100%',
					top: -1 * current_scrollY,
					left: menu_size
				});
				
				$(setting.menuID).css({
					left: 0
				}).after('<div id="wrapper_menu"></div>');
				
				menuflg = true;
				
			} else {
				
				$(setting.wrapperID).attr({style: ''});
				
				$(setting.closeBtn).css({
					display: 'none'
				});
				
				$(setting.menuID).css({
					left: -menu_size
				});
				
				$('#wrapper_menu').remove();
				$('html, body').prop({scrollTop: current_scrollY});
				menuflg = false;
			}
		}		
		
		$(setting.menuBtn).on('click', function(){
			visibleMenu();
		});
		
		$(setting.closeBtn).on('click', function(){
			visibleMenu();
		});
		
		if (setting.pageTop) {
        	$(setting.pagetopBtn).on('click', function(){
				var speed = 400;
				$('body,html').animate({scrollTop:0}, speed, 'swing');
				return false;
			});
        }
        
        return(this);
    };
})(jQuery);